require '4e_analysis'

describe Encounter do
	it "should end when the PC dies" do
		encounter = Encounter.new(TestCreature.new(:rounds_to_live => 3), TestCreature.new)
		encounter.rounds.should == 3
	end
	
	it "should end when the monster dies" do
		encounter = Encounter.new(TestCreature.new, TestCreature.new(:rounds_to_live => 3))
		encounter.rounds.should == 3
	end
	
	it "should end when both combatants die simultaneously" do
		encounter = Encounter.new(
			TestCreature.new(:rounds_to_live => 3),
			TestCreature.new(:rounds_to_live => 3)
		)
		encounter.rounds.should == 3
	end
end

describe Round do
	it "should give each combatant a turn" do
		pc = TestCreature.new
		monster = TestCreature.new
		round = Round.new(pc, monster)

		round.simulate
		pc.had_turn?.should == true
		monster.had_turn?.should == true
	end
end