require '4e_analysis'

class Encounter
	def initialize(pc, monster, report=Report.new)
		@pc = pc
		@monster = monster
		@report = report
		pc.report = report
		monster.report = report
	end
		
	def simulate
		@rounds = 0
		until @pc.dead? || @monster.dead?
			@rounds += 1
			@report.puts "Round #{rounds}:" do
				round = Round.new(@pc, @monster, @report)
				round.simulate
				@report.puts
			end
		end
		if @pc.dead? && @monster.dead?
			@report.puts "Rocks fall, everybody dies."
		elsif @pc.dead?
			@report.puts "Villains win!"
		else
			@report.puts "Heroes win!"
		end
		return @rounds
	end
		
	def rounds
		simulate unless @rounds
		return @rounds
	end

	private
	
	def report_combatants
		@report.puts "#{@pc} vs. #{@monster}"
		@report.puts
		@pc.report
		@report.puts
		@monster.report
		@report.puts		
	end
end

class Round
	def initialize(pc, monster, report=Report.new)
		@pc = pc
		@monster = monster
		@report = report
	end
	
	def simulate
		@pc.take_turn(@monster)
		@report.puts "#{@monster} has died!" if @monster.dead?
		@monster.take_turn(@pc) unless @monster.dead?
		@report.puts "#{@pc} has died!" if @pc.dead?
	end
end

