class Histogram
	MAX_TICKS = 67

	def initialize
		@data = {}
		@max_frequency = 0
		@total_value = 0
		@num_samples = 0
	end
	
	def increment(value)
		@data[value] = 0 unless @data[value]
		new_frequency = (@data[value] += 1)

		@max_frequency = new_frequency if new_frequency > @max_frequency
		@total_value += value
		@num_samples += 1
	end

	def max_frequency
		@max_frequency
	end
	
	def average
		@total_value.to_f / @num_samples
	end
	
	def print
		cumulative_rounds = 0
		@data.keys.sort.each do |key|
			value = ""
		  
			rounds = @data[key]
			cumulative_rounds += rounds
			ticks = (rounds.to_f / max_frequency.to_f * MAX_TICKS).to_i
			ticks.times do
				value += "="
			end
			percent = (cumulative_rounds * 100).to_f / @num_samples
			key_s = key.to_s.rjust(3) + "(#{'%.1f' % percent}%)".rjust(8) + ":"
			puts "#{key_s} #{value}" if value != ""
		end
	end
end