require '4e_analysis'

class Report
	def initialize(output=nil)
		@output = output
		@indent = 0
	end
	
	def print(string)
		return unless @output
		indent unless @indented
		@output.print(string)
	end
	
	def puts(string="", &proc)
		print "#{string}\n"
		@indented = false
		if proc
			@indent += 1
			proc.call
			@indent -= 1
		end
	end
	
	def headline(string)
		puts "[b]#{string}[/b]"
	end
		
	def hide(string, &proc)
		puts "[sblock=#{string}]"
		proc.call
		puts "[/sblock]"
	end

	private
	
	def indent
		(@indent * 2).times do
			@output.print " "
		end
		@indented = true
	end
end